"""LCM type definitions
This file automatically generated by lcm.
DO NOT MODIFY BY HAND!!!!
"""

try:
    import cStringIO.StringIO as BytesIO
except ImportError:
    from io import BytesIO
import struct

class gps_lcm(object):
    __slots__ = ["time", "latitude", "longitude", "altitude", "utm_x", "utm_y"]

    def __init__(self):
        self.time = 0.0
        self.latitude = 0.0
        self.longitude = 0.0
        self.altitude = 0.0
        self.utm_x = 0.0
        self.utm_y = 0.0

    def encode(self):
        buf = BytesIO()
        buf.write(gps_lcm._get_packed_fingerprint())
        self._encode_one(buf)
        return buf.getvalue()

    def _encode_one(self, buf):
        buf.write(struct.pack(">dddddd", self.time, self.latitude, self.longitude, self.altitude, self.utm_x, self.utm_y))

    def decode(data):
        if hasattr(data, 'read'):
            buf = data
        else:
            buf = BytesIO(data)
        if buf.read(8) != gps_lcm._get_packed_fingerprint():
            raise ValueError("Decode error")
        return gps_lcm._decode_one(buf)
    decode = staticmethod(decode)

    def _decode_one(buf):
        self = gps_lcm()
        self.time, self.latitude, self.longitude, self.altitude, self.utm_x, self.utm_y = struct.unpack(">dddddd", buf.read(48))
        return self
    _decode_one = staticmethod(_decode_one)

    _hash = None
    def _get_hash_recursive(parents):
        if gps_lcm in parents: return 0
        tmphash = (0xd7822a9a8512aa3b) & 0xffffffffffffffff
        tmphash  = (((tmphash<<1)&0xffffffffffffffff)  + (tmphash>>63)) & 0xffffffffffffffff
        return tmphash
    _get_hash_recursive = staticmethod(_get_hash_recursive)
    _packed_fingerprint = None

    def _get_packed_fingerprint():
        if gps_lcm._packed_fingerprint is None:
            gps_lcm._packed_fingerprint = struct.pack(">Q", gps_lcm._get_hash_recursive([]))
        return gps_lcm._packed_fingerprint
    _get_packed_fingerprint = staticmethod(_get_packed_fingerprint)

